package dche.component;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.FlowLayout;
import java.awt.Panel;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.HashMap;
import dche.DcheDataModel;

//--------------------------------------------------------------------//
/**
 * ANVǗNX
 */
public class DcheActionManager
  implements MouseListener,MouseMotionListener,KeyListener{

/** \LoX */
  protected DcheViewCanvas canvas;

/** }EXʒu */
  protected Point mousePoint;

/** ANVL[i[}bv */
  protected HashMap keyMap;

/** pl */
  protected Panel controlPanel;

/**
 * ANVǗIuWFNg\z
 * @param canvas \LoX
 */
  public DcheActionManager(DcheViewCanvas canvas){
    this.canvas=canvas;
    canvas.addMouseListener(this);
    canvas.addMouseMotionListener(this);
    canvas.addKeyListener(this);
    mousePoint=new Point();

    keyMap=new HashMap();
    controlPanel=new DcheControlPanel(canvas);
  }

//--------------------------------------------------------------------//
/**
 * DCHE f[^fԂ
 * @return DCHE f[^f
 */
  public DcheDataModel getModel(){
    return canvas.getModel();
  }

//--------------------------------------------------------------------//
/**
 * \LoXԂ
 * @return \LoX
 */
  public DcheViewCanvas getViewCanvas(){
    return canvas;
  }

//--------------------------------------------------------------------//
/**
 * plԂ
 * @return pl
 */
  public Panel getControlPanel(){
    return controlPanel;
  }

//--------------------------------------------------------------------//
/**
 * }EX{^̏s
 * @param e }EXANVƂCxg
 */
  public void mousePressed(MouseEvent e){
    mousePoint.setLocation(e.getX(),e.getY());
  }

//--------------------------------------------------------------------//
/**
 * }EX{^𗣂̏s
 * @param e }EXANVƂCxg
 */
  public void mouseReleased(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXNbN̏s
 * @param e }EXANVƂCxg
 */
  public void mouseClicked(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXR|[lgɓ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseEntered(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXR|[lgȍs
 * @param e }EXANVƂCxg
 */
  public void mouseExited(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXړ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseMoved(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXhbȌs
 * @param e }EXANVƂCxg
 */
  public void mouseDragged(MouseEvent e){
    int x=e.getX();
    int y=e.getY();
    if(e.isShiftDown()){
      canvas.translate(x-mousePoint.x,y-mousePoint.y);
    }
    else if(e.isControlDown()){
      canvas.zoom(x-mousePoint.x,y-mousePoint.y);
    }
    else{
      canvas.translate(x-mousePoint.x,y-mousePoint.y);
//      canvas.rotate(x-mousePoint.x,y-mousePoint.y);
    }
    mousePoint.setLocation(x,y);
    canvas.repaint();
  }

//--------------------------------------------------------------------//
/**
 * L[̏s
 * @param e L[ANVƂCxg
 */
  public void keyPressed(KeyEvent e){
  }

//--------------------------------------------------------------------//
/**
 * L[𗣂̏s
 * @param e L[ANVƂCxg
 */
  public void keyReleased(KeyEvent e){
  }

//--------------------------------------------------------------------//
/**
 * L[^Cv̏s
 * @param e L[ANVƂCxg
 */
  public void keyTyped(KeyEvent e){
  }
}
