package dche.component;
import java.awt.FlowLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import dche.DcheDataModel;
import fem.result.Result;

//--------------------------------------------------------------------//
/**
 * pl
 */
public class DcheControlPanel extends Panel{

/** vZʂ̎ނi[z */
  public static final String
    PARAMS[]={"None","Temperature"};

/** \LoX */
  protected DcheViewCanvas canvas;

/** R^[\f[^̎ނ\ int ^ */
  protected int contourParam;

/** vZʂ̎ނ\Ɛl֘At}bv */
  protected HashMap<String,Integer> parameterMap;

/** vZ{^ */
  protected CalculateButton calc;

/** vZʏ{^ */
  protected ClearResultButton clear;

/** \ʐIj[ */
//  protected ResultChoice res;

/**
 * pl\z
 * @param canvas \LoX
 */
  public DcheControlPanel(DcheViewCanvas canvas){
    super(new FlowLayout());
    this.canvas=canvas;
    contourParam=Result.NONE;
    calc=new CalculateButton(this);
    clear=new ClearResultButton(canvas);
//    res=new ResultChoice(this);
    add(calc);
    add(clear);
//    add(res);
    setMaps();
  }

//--------------------------------------------------------------------//
/**
 * }bvݒ肷
 */
  protected void setMaps(){
    parameterMap=new HashMap<String,Integer>();
    parameterMap.put(PARAMS[0],Result.NONE);
    parameterMap.put(PARAMS[1],Result.TEMPERATURE);
  }

//--------------------------------------------------------------------//
/**
 * DCHE f[^fԂ
 * @return DCHE f[^f
 */
  public DcheDataModel getModel(){
    return canvas.getModel();
  }

//--------------------------------------------------------------------//
/**
 * \LoXԂ
 * @return \LoX
 */
  public DcheViewCanvas getViewCanvas(){
    return canvas;
  }

//--------------------------------------------------------------------//
/**
 * R^[\f[^̎ނݒ肷
 * @param value f[^
  public void setContourParam(String value){
    Integer param=parameterMap.get(value);
    if(param==null) return;
    contourParam=param.intValue();
//    canvas.setContour(contourParam);
  }
 */
}
