package dche.io;
import java.io.BufferedReader;
import java.io.PrintWriter;
import dche.DcheDataModel;
import fem.MeshModel;
import fem.result.Result;
import fileio.TextDataIO;

//--------------------------------------------------------------------//
/**
 * DCHE ʏo̓NX
 */
public class DcheResultWriter extends TextDataIO{

/** DCHE f[^f */
  protected DcheDataModel model;

/**
 * DCHE ʏo̓IuWFNg\z
 * @param model DCHE f[^f
 */
  public DcheResultWriter(DcheDataModel model){
    this.model=model;
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param name f[^
 * @param br ̓[_[
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public void readData(String name,BufferedReader br) throws Exception{
  }

//--------------------------------------------------------------------//
/**
 * f[^
 * @param pw o̓C^[
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public void writeData(PrintWriter pw) throws Exception{
    MeshModel mesh=model.getMesh();
    Result result=model.getResult();
    int count=result.size();
    int mon[]=model.getMonitor();
    pw.println("Monitor:");
    for(int i=0;i<mon.length;i++){
      pw.print(mesh.getNode(mon[i]).label());
      pw.print('\t');
      pw.println(result.getTemperature(mon[i]));
    }
    pw.println("All:");
    for(int i=0;i<count;i++){
      pw.print(mesh.getNode(i).label());
      pw.print('\t');
      pw.println(result.getTemperature(i));
    }
  }
}
