package fem;
import java.util.HashMap;

//--------------------------------------------------------------------//
/**
 * f[^xi[}bv
 */
public class LabelMap{

/** f[^xi[}bv */
  protected HashMap<Integer,Integer> labelMap;

/**
 * f[^xi[}bv\z
 */
  public LabelMap(){
    labelMap=new HashMap<Integer,Integer>();
  }

//--------------------------------------------------------------------//
/**
 * f[^i[
 * @param data xtf[^
 * @param index f[^̃CfbNX
 */
  public void put(LabeledData data,int index){
    labelMap.put(data.label(),index);
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @param label f[^x
 * @return f[^̃CfbNX
 */
  public Integer get(int label){
    return labelMap.get(label);
  }

//--------------------------------------------------------------------//
/**
 * f[^xĐݒ肷
 * @param data xtf[^
 * @throws LabelException Yf[^݂ȂƂ
 */
  public void reset(LabeledData data) throws LabelException{
    Integer newLabel=labelMap.get(data.label());
    if(newLabel!=null){
      data.setLabel(newLabel.intValue());
    }
    else{
      throw new LabelException("Bad node label");
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^xĐݒ肷
 * @param nodes ߓ_W
 * @throws LabelException Yf[^݂ȂƂ
 */
  public void reset(Nodes nodes) throws LabelException{
    int nodeCount=nodes.nodeCount();
    for(int i=0;i<nodeCount;i++){
      Integer newLabel=labelMap.get(nodes.node(i));
      if(newLabel!=null){
      	nodes.resetNodeLabel(i,newLabel.intValue());
      }
      else{
      	throw new LabelException("Bad node label");
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^
 */
  public void clear(){
    labelMap.clear();
  }
}
