package fem.border;
import java.util.Arrays;
import fem.AbstractNodes;
import fem.ElementBorder;
import fem.Node;

//--------------------------------------------------------------------//
/**
 * vfE̒ۃX[p[NX
 */
public abstract class AbstractElementBorder extends AbstractNodes
  implements Cloneable,ElementBorder{

/** vfx */
  public int element;

  protected AbstractElementBorder(int element){
    super();
    this.element=element;
  }

//--------------------------------------------------------------------//
/**
 * vfÊԂ
 * @return vfE
 */
  public abstract String getName();

//--------------------------------------------------------------------//
/**
 * vfxԂ
 * @return vfx
 */
  public int element(){
    return element;
  }

//--------------------------------------------------------------------//
/**
 * vfxĐݒ肷
 * @param element vfx
 */
  public void resetElementLabel(int element){
    this.element=element;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    return copyBorder();
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public ElementBorder copyBorder(){
    try{
      AbstractElementBorder border=(AbstractElementBorder)super.clone();
      border.nodes=new int[nodes.length];
      System.arraycopy(nodes,0,border.nodes,0,nodes.length);
      return border;
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    int p[]=(int[])nodes().clone();
    Arrays.sort(p);
    int bit=0;
    for(int i=0;i<p.length;i++){
      bit=31*bit+p[i];
    }
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>AbstractElementBorder</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof AbstractElementBorder){
      AbstractElementBorder eb=(AbstractElementBorder)obj;
      int p1[]=(int[])nodes().clone();
      int p2[]=(int[])eb.nodes().clone();
      if(p1.length!=p2.length) return false;
      Arrays.sort(p1);
      Arrays.sort(p2);
      return Arrays.equals(p1,p2);
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    StringBuilder sb=new StringBuilder(getName());
    sb.append('\t');
    sb.append(element);
    int nodeCount=nodeCount();
    for(int i=0;i<nodeCount;i++){
      sb.append('\t');
      sb.append(nodes[i]);
    }
    return sb.toString();
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @param p ߓ_i[z
 * @return ̃IuWFNg̕\
 */
  public String toString(Node p[]){
    StringBuilder sb=new StringBuilder(getName());
    sb.append('\t');
    sb.append(element);
    int nodeCount=nodeCount();
    for(int i=0;i<nodeCount;i++){
      sb.append('\t');
      sb.append(p[i].label());
    }
    return sb.toString();
  }
}
