package data;
import java.text.DecimalFormat;

//--------------------------------------------------------------------//
/**
 * l
 */
public class NumberString{

  private static final DecimalFormat
    FORMS[]={new DecimalFormat("0.0####E00"),
      	     new DecimalFormat("0.0#####"),
      	     new DecimalFormat("####0.0###")};

//--------------------------------------------------------------------//
/**
 * l𕶎ɕϊ
 * @param value l
 * @return l\
 */
  public static String toString(double value){
    double av=Math.abs(value);
    if(av==0.0){
      return "0.0";
    }
    else if(av<=1.0E-4){
      return FORMS[0].format(value);
    }
    else if(av<1.0){
      return FORMS[1].format(value);
    }
    else if(av<1.0E4){
      return FORMS[2].format(value);
    }
    else{
      return FORMS[0].format(value);
    }
  }
}
