package fem;
import java.awt.geom.Point2D;
import figure.Matrix;

//--------------------------------------------------------------------//
/**
 * QvfC^[tFCX
 */
public interface Element2D extends GaussianQuadrature,LabeledData,Nodes{

//--------------------------------------------------------------------//
/**
 * ޗ̃CfbNXԂ
 * @return ޗ̃CfbNX
 */
  int getMaterial();

/**
 * ޗ̃CfbNXݒ肷
 * @param material ޗ̃CfbNX
 */
  void setMaterial(int material);

/**
 * vfEԂ
 * @return vfE
 */
  int borderCount();

/**
 * vfEԂ
 * @param element vfx
 * @return vfEi[z
 */
  ElementBorder[] borders(int element);

/**
 * vfEԂ
 * @param element vfx
 * @param index vfẼCfbNX
 * @return vfEi[z
 */
  ElementBorder border(int element,int index);

/**
 * vfߓ_̊pxԂ
 * @param p ߓ_i[z
 * @return vfߓ_̊pxi[z
 */
  double[] angle(Point2D p[]);

/**
 * `֐s<br>
 * { <i>N<sub>i</sub></i>
 *   <i>dN<sub>i</sub></i> /<i>d</i>
 *   <i>dN<sub>i</sub></i> /<i>d</i> }<br>
 * Ԃ
 * @param xsi <i></i> W
 * @param eta <i></i> W
 * @return `֐s
 */
  Matrix shapeFunction(double xsi,double eta);

/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param material ޗ
 * @return `֐}gbNX
 */
  Matrix shapeFunctionMatrix(Point2D p[],Material material);

/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐}gbNX
 */
  Matrix shapeFunctionMatrix(Point2D p[],double coef);

/**
 * gU}gbNX<br>
 * { <i>N<sub>i</sub></i>E<i>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param material ޗ
 * @return gU}gbNX
 */
  Matrix gradMatrix(Point2D p[],Material material);

/**
 * gU}gbNX<br>
 * { <i>N<sub>i</sub></i>E<i>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return gU}gbNX
 */
  Matrix gradMatrix(Point2D p[],double coef);

/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  Element2D copyElement();

/**
 * f[^Ԃ
 * @param material ޗx
 * @param p ߓ_i[z
 * @return ̃IuWFNg̕\
 */
  String toString(int material,Node p[]);
}
