package fem;

//--------------------------------------------------------------------//
/**
 * ޗNX
 */
public class Material implements Cloneable,LabeledData{

/** ޗԍ */
  public int label;

/** x */
  public double density;

/** M */
  public double specificHeat;

/** M` */
  public double heatConductivity;

/** ̐ϔM */
  public double cv;

/**
 * ޗ\z
 * @param label ޗԍ
 */
  public Material(int label){
    this(label,1.0,1.0,1.0);
  }

/**
 * ޗ\z
 * @param label ޗԍ
 * @param density x
 * @param specificHeat M
 * @param heatConductivity M`
 */
  public Material(int label,double density,double specificHeat,
      	      	  double heatConductivity){
    this.label=label;
    this.density=density;
    this.specificHeat=specificHeat;
    this.heatConductivity=heatConductivity;
    cv=density*specificHeat;
  }

//--------------------------------------------------------------------//
/**
 * ޗԍԂ
 * @return ޗԍ
 */
  public int label(){
    return label;
  }

//--------------------------------------------------------------------//
/**
 * ޗԍݒ肷
 * @param label ޗԍ
 */
  public void setLabel(int label){
    this.label=label;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    long ll[]={Double.doubleToLongBits(density),
      	       Double.doubleToLongBits(specificHeat),
      	       Double.doubleToLongBits(heatConductivity),
      	       Double.doubleToLongBits(cv)};
    int bit=label;
    for(int i=0;i<ll.length;i++){
      bit=31*bit+(int)(ll[i]^(ll[i]>>>32));
    }
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Material</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Material){
      Material m=(Material)obj;
      return ((label==m.label)
      	   && (density==m.density)
      	   && (specificHeat==m.specificHeat)
      	   && (heatConductivity==m.heatConductivity));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Material\t"+label+"\t"+density+"\t"+specificHeat+"\t"
      	  +heatConductivity;
  }
}
