package fem.bc;
import fem.Element2D;
import fem.ElementBorder;
import fem.LabeledData;

//--------------------------------------------------------------------//
/**
 * vfENX
 */
public class ElementBorderBound implements LabeledData{

/** vfx */
  public int element;

/** vfE */
  public String face;

/**
 * vfE\z
 * @param element vfx
 * @param face vfE
 */
  public ElementBorderBound(int element,String face){
    this.element=element;
    this.face=face;
  }

//--------------------------------------------------------------------//
/**
 * vfxԂ
 * @return vfx
 */
  public int label(){
    return element;
  }

//--------------------------------------------------------------------//
/**
 * vfxݒ肷
 * @param element vfx
 */
  public void setLabel(int element){
    this.element=element;
  }

//--------------------------------------------------------------------//
/**
 * vfEԂ
 * @param element vf
 * @return ̖ʈvfE
 */
  public ElementBorder getBorder(Element2D element){
    if(face.equals("F1")){
      return element.border(this.element,0);
    }
    else if(face.equals("F2")){
      return element.border(this.element,1);
    }
    else if(face.equals("F3")){
      return element.border(this.element,2);
    }
    else if(face.equals("F4")){
      return element.border(this.element,3);
    }
    else if(face.equals("F5")){
      return element.border(this.element,4);
    }
    else if(face.equals("F6")){
      return element.border(this.element,5);
    }
    else{
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    return 31*element+face.hashCode();
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @return rΏۂ̃IuWFNg <code>ElementBorderBound</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof ElementBorderBound){
      ElementBorderBound b=(ElementBorderBound)obj;
      return ((element==b.element) && face.equals(b.face));
    }
    else{
      return false;
    }
  }
}
