package fem.bc;

//--------------------------------------------------------------------//
/**
 * M`BENX
 */
public class HeatTransferBound extends ElementBorderBound{

/** M`B */
  public double htc;

/** Ox */
  public double outTemp;

/**
 * M`BE\z
 * @param element vfx
 * @param face vfE
 * @param htc M`B
 * @param outTemp Ox
 */
  public HeatTransferBound(int element,String face,double htc,
      	      	      	   double outTemp){
    super(element,face);
    this.htc=htc;
    this.outTemp=outTemp;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @return rΏۂ̃IuWFNg <code>HeatTransferBound</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof HeatTransferBound){
      if(!super.equals(obj)) return false;
      HeatTransferBound h=(HeatTransferBound)obj;
      return ((htc==h.htc) && (outTemp==h.outTemp));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return toString(element);
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @param element vfx
 * @return ̃IuWFNg̕\
 */
  public String toString(int element){
    return "HTC\t"+element+"\t"+face+"\t"+htc+"\t"+outTemp;
  }
}
