package fem.result;
import gui.ColorBar;

//--------------------------------------------------------------------//
/**
 * R^[}f[^NX
 */
public class ContourData{

/** f[^̍ŏl */
  protected double minValue;

/** f[^̍ől */
  protected double maxValue;

/** ߓ_̒li[z */
  protected double value[];

/**
 * R^[}f[^IuWFNg\z
 */
  public ContourData(){
    clear();
  }

//--------------------------------------------------------------------//
/**
 * R^[
 */
  public void clear(){
    maxValue=0.0;
    minValue=0.0;
    value=null;
  }

//--------------------------------------------------------------------//
/**
 * R^[}f[^ݒ肷
 * @param result vZ
 * @param param f[^̎ނ\ int ^
 */
  public void setContour(Result result,int param){
    int nodeCount=result.size();
    if(nodeCount<=0) return;
    value=new double[nodeCount];
    value[0]=result.getData(param,0);
    minValue=value[0];
    maxValue=value[0];
    for(int i=1;i<nodeCount;i++){
      value[i]=result.getData(param,i);
      minValue=Math.min(minValue,value[i]);
      maxValue=Math.max(maxValue,value[i]);
    }
  }

//--------------------------------------------------------------------//
/**
 * ߓ_̒lԂ
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽʒu̒l
 */
  public double getContourData(int index){
    return value[index];
  }

//--------------------------------------------------------------------//
/**
 * ftHg̃J[o[Ԃ
 * @return J[o[
 */
  public ColorBar colorbar(){
    return new ColorBar.Standard(maxValue,minValue);
  }
}
